{$Error This is a closed source unit. You cannot compile it, it was already compiled.}
{$Error Probably the IDE has cleaned up and you have to unpack the zip again.}
{********************************************************************}
{                                                                    }
{ written by TMS Software                                            }
{            copyright (c) 2018                                      }
{            Email : info@tmssoftware.com                            }
{            Web : http://www.tmssoftware.com                        }
{                                                                    }
{ The source code is given as is. The author is not responsible      }
{ for any possible damage done due to the use of this code.          }
{ The complete source code remains property of the author and may    }
{ not be distributed, published, given or sold in any form as such.  }
{ No parts of the source code can be included in any other component }
{ or application without written authorization of the author.        }
{********************************************************************}

unit WEBLib.JQGrid;

interface

uses
  Classes, SysUtils, WebLib.Controls, js, libJQuery, jqwidget,
  WebLib.JQCtrls, types;

type
  TJQXGridColumnType = (gctDefault, gctEmail, gctLink, gctImage);
  TJQXGridEditor = (geEdit, geCheckBox, geDateTimeInput, geDropDownList, geNumberInput, geNone);
  TJQXGridSelection = (gsSingleCell, gsSingleRow, gsMultipleCells, gsMultipleRows);
//  TJQXGridScrollMode = (gsmPixelScrolling, gsmItemScrolling);
  TJQXGridSortDirection = (gsdAscending, gsdDescending, gsdUnsorted);
  TJQXGridDataType = (gdtArray, gdtCSV, gdtJSON, gdtNone);
  TJQXGridColumnDataType = (gcdString, gcdInteger, gcdDouble, gcdDate);

  TJQXCellEventArgs = class(TPersistent)
  published
    property ACol: Integer read FACol write FACol;
    property ARow: Integer read FARow write FARow;
    property ADataField: string read FADataField write FADataField;
    property AId: string read FAId write FAId;
    property AValue: string read FAValue write FAValue;
  end;

  TJQXCellEvent = procedure(Sender: TObject; Event: TJQXCellEventArgs) of object;

  TJQXCellDataEventArgs = class(TPersistent)
  published
    property ACol: Integer read FACol write FACol;
    property ARow: Integer read FARow write FARow;
    property AData: string read FAData write FAData;
    property ADataField: string read FADataField write FADataField;
    property AId: string read FAId write FAId;
    property AValue: string read FAValue write FAValue;
  end;

  TJQXCellDataEvent = procedure(Sender: TObject; Event: TJQXCellDataEventArgs) of object;

  TJQXCellEditEventArgs = class(TPersistent)
  published
    property ACol: Integer read FACol write FACol;
    property ARow: Integer read FARow write FARow;
    property ADataField: string read FADataField write FADataField;
    property AId: string read FAId write FAId;
    property AValue: string read FAValue write FAValue;
    property AOldValue: string read FAOldValue write FAOldValue;
  end;

  TJQXCellEditEvent = procedure(Sender: TObject; Event: TJQXCellEditEventArgs) of object;

  TJQXCellValidateEventArgs = class(TPersistent)
  published
    property ACol: Integer read FACol write FACol;
    property ARow: Integer read FARow write FARow;
    property ADataField: string read FADataField write FADataField;
    property AId: string read FAId write FAId;
    property AValue: string read FAValue write FAValue;
    property AOldValue: string read FAOldValue write FAOldValue;
    property AAllow: Boolean read FAAllow write FAAllow default true;
    property AMessage: string read FAMessage write FAMessage;
  end;

  TJQXCellValidateEvent = procedure(Sender: TObject; Event: TJQXCellValidateEventArgs) of object;

  TJQXPageEventArgs = class(TPersistent)
  published
    property APageIndex: Integer read FAPageIndex write FAPageIndex;
    property APageSize: Integer read FAPageSize write FAPageSize;
  end;

  TJQXPageEvent = procedure(Sender: TObject; Event: TJQXPageEventArgs) of object;

  TJQXRowEventArgs = class(TPersistent)
  published
    property ARowIndex: Integer read FARowIndex write FARowIndex;
  end;

  TJQXRowEvent = procedure(Sender: TObject; Event: TJQXRowEventArgs) of object;

  TJQXSortEventArgs = class(TPersistent)
  published
    property ACol: Integer read FACol write FACol;
    property ADataField: string read FADataField write FADataField;
    property ASortDirection: TJQXGridSortDirection read FASortDirection write FASortDirection default gsdUnsorted;
  end;

  TJQXSortEvent = procedure(Sender: TObject; Event: TJQXSortEventArgs) of object;

  TJQXFilterEventArgs = class(TPersistent)
  published
    property ACol: Integer read FACol write FACol;
    property ADataField: string read FADataField write FADataField;
    property AValue: string read FAValue write FAValue;
    property ACondition: string read FACondition write FACondition;
  end;

  TJQXFilterEvent = procedure(Sender: TObject; Event: TJQXFilterEventArgs) of object;

  TJQXGrid = class;
  TJQXGridColumns = class;
  TJQXGridOptions = class;

  TJQXGridColumn = class(TCollectionItem)
  public
    constructor Create(Collection: TCollection);  override;
    destructor Destroy; override;
    procedure Assign(Source: TPersistent); override;
    function GetOwner: TPersistent; override;
  protected
    function GetDisplayName: string; override;
  published
    property Alignment: TAlignment read FAlignment write SetAlignment default taLeftJustify;
    property ColumnType: TJQXGridColumnType read FColumnType write FColumnType default gctDefault;
    property DataField: string read FDataField write SetDataField;
    property DataType: TJQXGridColumnDataType read FDataType write SetDataType;
    property Editor: TJQXGridEditor read FEditor write SetEditor default geEdit;
    property Freeze: Boolean read FFreeze write SetFreeze default False;
    property Format: string read FFormat write SetFormat;
    property Title: string read FTitle write SetTitle;
    property Visible: Boolean read FVisible write SetVisible default True;
    property Width: Integer read FWidth write SetWidth default 100;
  end;

  TJQXGridColumns = class(TCollection)
  protected
    procedure Update(Item: TCollectionItem); override;
  public
    constructor Create(AOwner: TJQXGrid); overload;
    function GetOwner: TPersistent; override;
    function Add: TJQXGridColumn; reintroduce;
    function Insert(Index: Integer):TJQXGridColumn; reintroduce;
    property Items[Index: Integer]: TJQXGridColumn read GetItems write SetItems; default;
  end;

  TJQXGridBands = class(TPersistent)
  public
    constructor Create(AOwner: TJQXGridOptions); overload;
    destructor Destroy; override;
    procedure Assign(Source: TPersistent); override;
    function GetOwner: TPersistent; override;

    property Enabled: Boolean read FEnabled write SetEnabled default False;
    property RowCount: Integer read FRowCount write SetRowCount default 1;
  end;

  TJQXGridPaging = class(TPersistent)
  public
    constructor Create(AOwner: TJQXGridOptions); overload;
    destructor Destroy; override;
    procedure Assign(Source: TPersistent); override;
    function GetOwner: TPersistent; override;

    property Enabled: Boolean read FEnabled write SetEnabled default False;
    property PageSize: Integer read FPageSize write SetPageSize default 10;
   end;

  TJQXGridSorting = class(TPersistent)
  public
    constructor Create(AOwner: TJQXGridOptions); overload;
    destructor Destroy; override;
    procedure Assign(Source: TPersistent); override;
    function GetOwner: TPersistent; override;

    property Enabled: Boolean read FEnabled write SetEnabled default False;
    property ColumnIndex: Integer read FColumnIndex write SetColumnIndex default -1;
    property Direction: TJQXGridSortDirection read FDirection write SetDirection default gsdAscending;
   end;

  TJQXGridOptions = class(TPersistent)
  public
    constructor Create(AOwner: TJQXGrid); overload;
    destructor Destroy; override;
    procedure Assign(Source: TPersistent); override;
    function GetOwner: TPersistent; override;
  published
    property Bands: TJQXGridBands read FBands write FBands;
    property Editing: Boolean read FEditing write SetEditing default True;
    property Filtering: Boolean read FFiltering write SetFiltering default False;
    property Grouping: Boolean read FGrouping write SetGrouping default False;
    property Hovering: Boolean read FHovering write SetHovering default True;
    property Paging: TJQXGridPaging read FPaging write FPaging;
    property Sorting: TJQXGridSorting read FSorting write FSorting;
    property SelectionMode: TJQXGridSelection read FSelectionMode
      write SetSelectionMode default gsSingleRow;
  end;

  TJQXGridData = class(TPersistent)
  public
    constructor Create(AOwner: TJQXGrid); overload;
    destructor Destroy; override;
    procedure Assign(Source: TPersistent); override;
    function GetOwner: TPersistent; override;

    property JSON: TJSJSON read FDataJSON write SetDataJSON;
    property DataArray: TJSArray read FDataArray write SetDataArray;
  published
    property DataType: TJQXGridDataType read FDataType write SetDataType default gdtJSON;
    property Url: string read FDataUrl write SetDataUrl;
    property Id: string read FDataId write SetDataId;
    property Delimiter: char read FDataDelimiter write SetDataDelimiter;
  end;

  TJQXGridCellRec = record
    Col, Row: Integer;
  end;

  TJQXGridExportState = (esExportStart, esExportNewRow, esExportDone, esExportSelRow, esExportFail, esExportNextRow, esExportFindRow);

  TJQXGridAdapter = class(TComponent)
  protected
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;
    procedure Initialize; virtual;
    procedure UpdateBounds; virtual;
    procedure SelectCell(ACell: TJQXGridCellRec); virtual;
    procedure CellEditValidateData(ACol, ARow: Integer; var CellString: String; var Allow: Boolean); virtual;
    procedure CellEditGetData(ACol, ARow: Integer; var CellString: String); virtual;
    procedure CellBeforeEdit(ACol, ARow: Integer); virtual;
    procedure GetCellData(ACol, ARow: Integer; ADataField: string; var ACellData: string); virtual;
    procedure ExportNotification(AState: TJQXGridExportState; ARow: Integer); virtual;
  public
    constructor Create(AOwner: TComponent); override;
  published
    property Active: Boolean read FActive write SetActive default False;
    property Grid: TJQXGrid read FGrid write SetGrid;
  end;

  TJQXGrid = class(TJQXCustomControl)
  protected
    function HandleRendered(Event: TJQXEvent): boolean;
    procedure ExportNotification(AState: TJQXGridExportState; ARow: Integer); virtual;
    procedure GetCellData(ACol, ARow: Integer; ADataField: string; var ACellData: string); virtual;
    procedure BindEvents; override;
    procedure InitJQuery; override;
    procedure UpdateElement; override;
    procedure UpdateSize;
    procedure UpdateFull;
    procedure UpdateVisuals;
    procedure UpdateVisualsBeforeData;
    procedure UpdateVisualsAfterData;
    procedure UpdateData;
    procedure UpdateSelectionMode;
    procedure ClearData;
    function ColumnsToArray(GetCellData, GetValidate: Pointer): TJSArray;
    function DataFieldsToArray: TJSArray;
    function GetColumnIndexByDataField(ADataField: string): integer;
    function GetColumnDataFieldByIndex(AIndex: Integer): string;
    function GetRowIndexByValue(ARowIndex: string): integer;
    property Adapter: TJQXGridAdapter read FAdapter write SetAdapter;
    property PrevFocusedCell: TJQXGridCellRec read GetPrevFocusedCell write SetPrevFocusedCell;
    procedure SetWidth(AValue: Integer); override;
    procedure SetHeight(AValue: Integer); override;
  public
    procedure CreateInitialize; override;
    destructor Destroy; override;
    procedure SetTheme(AValue: string); override;

    property Cells[Col, Row: Integer]: string read GetCells write SetCells;
    property RowSelect[Row: Integer]: Boolean read GetRowSelect write SetRowSelect;
    property FocusedCell: TJQXGridCellRec read GetFocusedCell write SetFocusedCell;

    procedure BeginUpdate; override;
    procedure EndUpdate; override;

    procedure DeleteRow(Row: integer);
    procedure DeleteRows(Row, Count: Integer); virtual;
    procedure InsertRow(Row: integer);
    procedure InsertRows(Row, Count: Integer); virtual;

    procedure SelectCell(ACell: TJQXGridCellRec);
    procedure SelectRow(ARow: Integer);
    property VisibleRowCount: Integer read GetVisibleRowCount;
  published
    property Columns: TJQXGridColumns read FColumns write SetColumns;
    property Data: TJQXGridData read FData write SetData;
    property Options: TJQXGridOptions read FOptions write SetOptions;
    property RowCount: Integer read GetRowCount write SetRowCount default 5;
    property RowHeight: Integer read FRowHeight write SetRowHeight default 28;
//    property ScrollMode: TJQXGridScrollMode read FScrollMode write SetScrollMode default gsmPixelScrolling;

    property OnCellEditDone: TJQXCellEditEvent read FOnCellEditDone write FOnCellEditDone;
    property OnCellEditStart: TJQXCellEvent read FOnCellEditStart write FOnCellEditStart;
    property OnCellEditValidate: TJQXCellValidateEvent read FOnCellEditValidate write FOnCellEditValidate;
    property OnCellClick: TJQXCellEvent read FOnCellClick write FOnCellClick;
    property OnCellSelect: TJQXCellEvent read FOnCellSelect write FOnCellSelect;
    property OnGetCellData: TJQXCellDataEvent read FOnGetCellData write FOnGetCellData;
    property OnPageChange: TJQXPageEvent read FOnPageChange write FOnPageChange;
    property OnRowClick: TJQXRowEvent read FOnRowClick write FOnRowClick;
    property OnRowSelect: TJQXRowEvent read FOnRowSelect write FOnRowSelect;
    property OnSort: TJQXSortEvent read FOnSort write FOnSort;
    property OnFilter: TJQXFilterEvent read FOnFilter write FOnFilter;
  end;

  TWebJQXGrid = class(TJQXGrid);

function MakeCell(ACol,ARow: integer): TJQXGridCellRec;

implementation
end.
